.\" -*- nroff -*-
.\" Copyright (c) 2001, Swedish Institute of Computer Science.
.\" All rights reserved. 
.\"
.\" Redistribution and use in source and binary forms, with or without 
.\" modification, are permitted provided that the following conditions 
.\" are met: 
.\"
.\" 1. Redistributions of source code must retain the above copyright 
.\"    notice, this list of conditions and the following disclaimer. 
.\"
.\" 2. Redistributions in binary form must reproduce the above copyright 
.\"    notice, this list of conditions and the following disclaimer in the 
.\"    documentation and/or other materials provided with the distribution. 
.\"
.\" 3. Neither the name of the Institute nor the names of its contributors 
.\"    may be used to endorse or promote products derived from this software 
.\"    without specific prior written permission. 
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND 
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE 
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
.\" SUCH DAMAGE. 
.\"
.\" This file is part of the lwIP TCP/IP stack.
.\" 
.\" Author: Adam Dunkels <adam@sics.se>
.\"
.\" $Id: unix.ms,v 1.3 2001/02/09 17:31:37 adam Exp $

.AM
.TL
Running lwIP under FreeBSD or Linux
.AU
Adam Dunkels <adam@sics.se>
.AB
These are some basic instructions for running lwIP under FreeBSD or
Linux.
.AE
.NH 1
Compiling
.LP
The \fCcompile/\fR-directory in the main source tree of lwIP contains
Makefiles for the different platforms. Currently, lwIP natively
supports the 6502 CPU as well as a simulation environment under
FreeBSD or Linux. The simulation environment makes it possible to run
lwIP as a user process, thus making debugging and development for both
the lwIP core and applications easier.
.PP
The Makefiles are named \fCMakefile\fR.\fIarch\fR, where \fIarch\fR is
the name of the target architecture. To compile the unix
environment, type:
.IP
\fC> cd compile\fR
.IP
\fC> gmake -f Makefile.unix\fR
.NH 1
Running lwIP in the unix environment
.LP
Currently, \fCMakefile.unix\fR creates two executables, \fCclient\fR
and \fCrouter\fR. These are indented to be simulate two hosts (small
clients) connected to each other, where one host (the \fCrouter\fR
executable) acts as a router and forwards packets to and from the
other (the \fCclient\fR).
.PP
Under FreeBSD, you will need to run the setup script in
\fCtools/bsd/\fR. This will set up the correct routes in the kernel. 
.PP
Start the router (as root):
.IP
\fC# ./router\fR
.PP
When the router says "now start client", run the client in another
window:
.IP
\fC> ./client\fR
.PP
Now it should be possible to reach the router and the client on the
following IP addresses:
.LP
.nf
.ce 4
\fC
10.0.0.1          10.0.0.2/10.0.1.1               10.0.1.2 
+---------+           +--------+                  +--------+
| FreeBSD |--(tun0)-->| router |--(unix socket)-->| client |
+---------+           +--------+                  +--------+
\fR
.PP
The client is connected to the router through an emmulated connection
whos bandwidth and queue length can be changed in the file
\fCarch/unix/netif/unixif.c\fR. The emulation runs on top of a unix
domain socket. Now, a few things may be tested:
.LP
.nf
\fC> traceroute -n 10.0.1.2\fR
.LP
.nf
\fC> ping 10.0.0.2
PING 10.0.0.2 (10.0.0.2): 56 data bytes
64 bytes from 10.0.0.2: icmp_seq=0 ttl=255 time=0.488 ms
64 bytes from 10.0.0.2: icmp_seq=1 ttl=255 time=0.519 ms
64 bytes from 10.0.0.2: icmp_seq=2 ttl=255 time=0.729 ms\fR
.LP
.nf
\fC> ping 10.0.1.2
PING 10.0.1.2 (10.0.1.2): 56 data bytes
64 bytes from 10.0.1.2: icmp_seq=0 ttl=253 time=202.379 ms
64 bytes from 10.0.1.2: icmp_seq=1 ttl=253 time=200.605 ms
64 bytes from 10.0.1.2: icmp_seq=2 ttl=253 time=200.498 ms\fR
.LP
.nf
\fC> telnet 10.0.1.2 systat\fR
.LP
.nf
\fC> telnet 10.0.0.2 systat\fR
.LP
.nf
(in netscape) http://10.0.1.2/index.html, http://10.0.0.2/index.html


