/*
 * Copyright (c) 2001, Swedish Institute of Computer Science.
 * All rights reserved. 
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 *
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the distribution. 
 *
 * 3. Neither the name of the Institute nor the names of its contributors 
 *    may be used to endorse or promote products derived from this software 
 *    without specific prior written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE 
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE. 
 *
 * This file is part of the lwIP TCP/IP stack.
 * 
 * Author: Adam Dunkels <adam@sics.se>
 *
 * $Id: systat.c,v 1.5 2001/02/22 13:01:00 adam Exp $
 */

#include "lwip/debug.h"
#include "lwip/opt.h"

#include "systat.h"
#include "lwip/stats.h"

/*#include <stdio.h>*/

#include "lwip/def.h"
#include "lwip/tcp.h"

#ifdef STATS
static char buf[2000];
#endif /* STATS */
/*-----------------------------------------------------------------------------------*/
static void
systat_accept(void *arg, struct tcp_pcb *pcb, int err)
{
#ifdef STATS
  sprintf(buf, STATSF(stats));
  tcp_write(pcb, buf, strlen(buf), 0);
#endif /* STATS */
  tcp_close(pcb);
}
/*-----------------------------------------------------------------------------------*/
void
systat_init(void)
{
  struct tcp_pcb *pcb;
  
  pcb = tcp_pcb_new();
  tcp_bind(pcb, NULL, 11);
  tcp_listen(pcb);
  tcp_accept(pcb, systat_accept, NULL);

}
/*-----------------------------------------------------------------------------------*/
